﻿EnableExplicit

;icon from https://www.iconfinder.com/icons/15568/fullscreen_window_icon

Global icon

#title="FullScreenEnabler"
#version="1.1"

Global NewList Monitor.monitorinfo()
Global monitorCount
Procedure monEnum(hmonitor,hdc,lprect,*i.Integer)
  AddElement(monitor())
  monitor()\cbSize=SizeOf(monitorinfoex)
  GetMonitorInfo_(hmonitor,@monitor())
  monitorCount+1
  ProcedureReturn #True
EndProcedure
Procedure CheckInMonitor(x,y,w,h)
  Protected ret=#False
  Protected xx=x+w-1,yy=y+h-1
  ;Debug "check"
  ForEach monitor()
;     Debug "----"
;     Debug ""+monitor()\rcMonitor\left+" - "+x +" "+Monitor()\rcMonitor\right
;     Debug ""+monitor()\rcMonitor\top +" - "+y +" "+Monitor()\rcMonitor\bottom
;     Debug ""+monitor()\rcMonitor\left+" - "+xx+" "+Monitor()\rcMonitor\right
;     Debug ""+monitor()\rcMonitor\top +" - "+yy+" "+Monitor()\rcMonitor\bottom
;     
    If (x >= Monitor()\rcMonitor\left And x <= Monitor()\rcMonitor\right And
        y >= Monitor()\rcMonitor\top  And y <= Monitor()\rcMonitor\bottom) Or
       (xx>= Monitor()\rcMonitor\left And xx<= Monitor()\rcMonitor\right And
        yy>= Monitor()\rcMonitor\top  And yy<= Monitor()\rcMonitor\bottom)
      ret=#True
      Break
    EndIf
  Next
  ProcedureReturn ret
EndProcedure
Macro CheckInMonitorRect(a)
  CheckInMonitor(a\left,a\top,a\right-a\left,a\bottom-a\top)
EndMacro
   

EnumDisplayMonitors_(#Null,#Null,@monEnum(),#Null)


Procedure MaxWindow(handle,mon,noframe,work)
  Protected winstyle,oldstyle,newstyle,*rect.rect
  
  If SelectElement(Monitor(),mon)
    ;Debug "Maximize:"+handle+" "+mon+" "+noframe
    
    If IsZoomed_(handle)
      ;Debug "Window is maximazed"
      ShowWindow_(handle,#SW_RESTORE)      
    EndIf
    
    
    #SWP_ASYNCWINDOWPOS  = $4000
    ;If noframe
    
    winstyle=GetWindowLongPtr_(handle, #GWL_STYLE)
    oldstyle=winstyle & ( #WS_BORDER|#WS_SIZEBOX|#WS_DLGFRAME)
    If noframe=-1
      noframe=winstyle
    EndIf    
    noframe & ( #WS_BORDER|#WS_SIZEBOX|#WS_DLGFRAME)
    
    newstyle=(winstyle & ~( #WS_BORDER|#WS_SIZEBOX|#WS_DLGFRAME)) | noframe 
    If winstyle<>newstyle
      SetWindowLongPtr_(handle, #GWL_STYLE,  newstyle)  
      SetWindowPos_(handle, #Null, 0,0,0,0, #SWP_FRAMECHANGED)
    EndIf
    
    If work
      *rect=Monitor()\rcWork
    Else
      *rect=monitor()\rcMonitor
    EndIf
    
    

    Debug "Maximize "+handle
;     SetWindowPos_(handle,0,
;                   Monitor()\rcWork\left,
;                   Monitor()\rcWork\top,
;                   Monitor()\rcWork\right-Monitor()\rcWork\left,
;                   Monitor()\rcWork\bottom-Monitor()\rcWork\top,
;                   #SWP_ASYNCWINDOWPOS|#SWP_NOOWNERZORDER)
    MoveWindow_(handle,
                *rect\left,
                *rect\top,
                *rect\right-*rect\left,
                *rect\bottom-*rect\top,
                #True)

    
    
     If noframe    
       ;Debug "MAXIMIZE"
       ShowWindow_(handle,#SW_MAXIMIZE)
     EndIf
        
  EndIf
  
  ProcedureReturn oldstyle
  
EndProcedure


Global winx,winy,winw=-1,winh=-1,minWidth=400,minHeight=400,closeDelay=5
#maxtitle=1024
Global *buf=AllocateMemory(#maxtitle*SizeOf(character))

Structure sWindowList
  Title.s
  Class.s
  enable.i
  shown.i
  ;founded.i
  ;maximized.i
  pos.i
  color.i
  monitor.i
  noFrame.i  
  ;oldstyle.i
  count.i
  firstclosed.i
EndStructure
Structure sHandleList
  handle.i
  found.i
  maximized.i
  oldstyle.i
  *window.sWindowList
EndStructure
  


Global NewMap Handlelist.sHandleList()
Global NewMap WindowList.sWindowList()

Enumeration frameset
  #frm__min
  #frm_default=#frm__min
  #frm_remove
  #frm_removemax  
  #frm__max
EndEnumeration


Macro MacroSettings()
  PreferenceGroup("Window")
  prefInteger(winX)
  prefInteger(winY)
  prefInteger(winW)
  prefInteger(winH)
  PreferenceGroup("Common")
  prefInteger(minWidth)
  prefInteger(minHeight)
  prefInteger(closeDelay)
EndMacro

Macro dquote
  "
EndMacro

Macro prefInteger(a)
  WritePreferenceInteger(dquote#a#dquote,a)
EndMacro
Macro prefString(a)
  WritePreferenceString(dquote#a#dquote,a)
EndMacro
Procedure SaveSettings(file.s)
  Protected i
  CreatePreferences(file)
  MacroSettings()
  
  PreferenceGroup("WindowList")
  ForEach WindowList()
    If windowlist()\enable
      i+1
      WritePreferenceString("title_"+i,WindowList()\Title)
      WritePreferenceString("class_"+i,WindowList()\Class)
      WritePreferenceInteger("monitor_"+i,WindowList()\monitor)
      WritePreferenceInteger("noframe_"+i,WindowList()\noFrame)
    EndIf
  Next  
  WritePreferenceInteger("count",i)
  ClosePreferences()
EndProcedure

UndefineMacro prefInteger
UndefineMacro prefString
Macro prefInteger(a)
  a=ReadPreferenceInteger(dquote#a#dquote,a)
EndMacro
Macro prefString(a)
  a=ReadPreferenceString(dquote#a#dquote,a)
EndMacro
Procedure LoadSettings(file.s)
  Protected count,i,wintitle.s,winclass.s
  OpenPreferences(file)
  MacroSettings()
  
  PreferenceGroup("WindowList")
  count=ReadPreferenceInteger("count",0)
  For i=1 To count
    wintitle=ReadPreferenceString("title_"+i,"")
    winclass=ReadPreferenceString("class_"+i,"")    
    windowlist(wintitle+#LF$+winclass)
    WindowList()\monitor=ReadPreferenceInteger("monitor_"+i,0)
    WindowList()\noFrame=ReadPreferenceInteger("noframe_"+i,0)
    windowlist()\Title=wintitle
    WindowList()\Class=winclass
    WindowList()\enable=#PB_ListIcon_Checked    
  Next
  
  ClosePreferences()
  
EndProcedure



Global win,winvisible
Global gadList

Procedure GreyPos(gad,pos)
  Protected rgb,ro,go,bo,r1,r2,g1,g2,b1,b2,d1,d2
  SetGadgetItemColor(gad,pos,#PB_Gadget_FrontColor,#PB_Default)
  rgb=GetGadgetItemColor(gad,pos,#PB_Gadget_FrontColor)
  ro=Red(rgb)
  go=Green(rgb)
  bo=Blue(rgb)
  
  r1=ro*60/100
  g1=go*60/100
  b1=bo*60/100
  
  r2=ro*140/100
  g2=go*140/100
  b2=bo*140/100
  
  d1=ro-r1 + go-g1 + bo-b1
  d2=r2-ro + g2-go + b1-bo
  If d1>d2
    rgb= RGB(r1,g1,b1)
  Else
    rgb= RGB(r2,g2,b2)
  EndIf
  SetGadgetItemColor(gad,pos,#PB_Gadget_FrontColor,rgb)  
  
EndProcedure
Procedure NormalPos(gad,pos)
  SetGadgetItemColor(gad,pos,#PB_Gadget_FrontColor,#PB_Default)
EndProcedure
Procedure SetDisplayText(*window.swindowlist)
  Protected s.s
  If *window\monitor = -1
    s="X"
  Else
    s=Str(*window\monitor+1)
    Select *window\noFrame
      Case #frm_default
        s="["+s+"]"
      Case #frm_remove
        s="_"+s+"_"
    EndSelect
  EndIf
  SetGadgetItemText(gadList,*window\pos,s,2)
EndProcedure
Procedure WinResize()
  Protected w=WindowWidth(win)-10
  Protected ww
  ResizeGadget(gadList,5,5,w,WindowHeight(win)-10)
  ww=w-50-100
  ww/2
  SetGadgetItemAttribute(gadList,0,#PB_ListIcon_ColumnWidth,ww,0)
  SetGadgetItemAttribute(gadList,0,#PB_ListIcon_ColumnWidth,ww,1)
EndProcedure
Procedure EnumProc(Handle, lParam) 
  Protected wintext.s,winclass.s,pos,handleInstance,i
  Protected rect.rect
  
  Static shellInstance
  
  handleInstance=GetWindowLongPtr_(Handle,#GWLP_HINSTANCE)
  If shellInstance=0
    shellInstance=GetWindowLongPtr_(GetShellWindow_(),#GWLP_HINSTANCE)
  EndIf
;   If winInstance=0
;     winInstance=GetWindowLongPtr_(WindowID(win),#GWLP_HINSTANCE)
;   EndIf
  
  If GetWindowText_(handle,*buf,#maxtitle)
    wintext.s= PeekS(*buf)
  EndIf
  If GetClassName_(handle,*buf,#maxtitle)
    winclass.s= PeekS(*buf)
  EndIf
  
  
      
  If IsWindowVisible_(handle) And 
     wintext<>"" And
     handleInstance<>shellInstance And 
     handle<>WindowID(win) And 
     winclass<>"CabinetWClass" And
     winclass<>"TaskManagerWindow" And    
     GetWindowRect_(handle,rect) And 
     CheckInMonitorRect(rect) And rect\right-rect\left>minWidth And rect\bottom-rect\top>minHeight;And handleInstance<>winInstance
      
    If FindMapElement(WindowList(),wintext+#LF$+winclass) Or winvisible
      
                  
      WindowList(wintext+#LF$+winclass)
      
      If WindowList()\shown=#False
        AddGadgetItem(gadList,-1,wintext+#LF$+winclass) 
        pos=CountGadgetItems(gadList)-1        
        WindowList()\Title=wintext
        windowlist()\Class=winclass
        WindowList()\shown=#True
        windowlist()\pos=pos

        SetDisplayText(@WindowList())
        If WindowList()\enable
          SetGadgetItemState(gadList,pos,#PB_ListIcon_Checked)
        EndIf    
        SetGadgetItemData(gadList,pos,@WindowList())      
        
        ;Debug wintext+" "+winclass
        #GCLP_HMODULE=-16
        ;Debug Hex(GetWindowLongPtr_(Handle,#GWLP_HINSTANCE))+" "+Hex(GetWindowLongPtr_(GetShellWindow_(),#GWLP_HINSTANCE))
        ;Debug Hex(handle)+" "+Hex(GetParent_(handle))
        
      EndIf
      
      If FindMapElement(Handlelist(),""+handle)=0
        handlelist(""+handle)        
        Handlelist()\handle=handle
        Handlelist()\window=windowlist()
        handlelist()\oldstyle=-1
        WindowList()\count+1        
        
        Debug "new HANDLE:"+wintext+" "+winclass+" "+Hex(handle)+" "+Hex(GetParent_(handle))
       
        
      EndIf
      Handlelist()\found=#True
      
      If Handlelist()\maximized=#False And WindowList()\enable
        
        If WindowList()\monitor=-1
          If WindowList()\firstclosed<closeDelay
            WindowList()\firstclosed+1
            Debug wintext+" delay "+WindowList()\firstclosed
            If WindowList()\firstclosed>=closeDelay
              Debug wintext+" closed"
              SendMessage_(handle,#WM_CLOSE,0,0)
              WindowList()\firstclosed+1
            EndIf            
          EndIf
          
        Else
          If WindowList()\noFrame
            i=MaxWindow(handle,WindowList()\monitor,0,Bool(windowlist()\noFrame=#frm_default Or windowlist()\noFrame=#frm_remove))
            If i
              handlelist()\oldstyle=i
            EndIf
          Else
            MaxWindow(handle,windowlist()\monitor,Handlelist()\oldstyle,Bool(windowlist()\noFrame=#frm_default Or windowlist()\noFrame=#frm_remove))
            Handlelist()\oldstyle=-1
          EndIf
          Handlelist()\maximized=#True
        EndIf
      EndIf
    EndIf
    
    
  EndIf
   
  
  ProcedureReturn #True
EndProcedure 
Procedure FillList()
  Protected pos
  
  ClearGadgetItems(gadList)
  
  ForEach WindowList()
    WindowList()\shown=#False
    WindowList()\color=#False
    If windowlist()\enable=#False And WindowList()\count=0
      DeleteMapElement(windowlist())
    EndIf
  Next
  
  EnumWindows_(@EnumProc(), 0) 
  
  ForEach WindowList()
    If windowlist()\shown=#False
      AddGadgetItem(gadlist,-1,WindowList()\Title+#LF$+WindowList()\Class)
      pos=CountGadgetItems(gadList)-1
      
      WindowList()\shown=#True
      windowlist()\pos=pos
      SetDisplayText(@WindowList())
      If WindowList()\enable
        SetGadgetItemState(gadList,pos,#PB_ListIcon_Checked)
      EndIf
      SetGadgetItemData(gadList,pos,@WindowList())      
    EndIf
  Next
  
  
  
EndProcedure

Procedure Scan()
  ForEach Handlelist()
    Handlelist()\found=0
  Next
  
  EnumWindows_(@EnumProc(), 0) 
  
  ForEach Handlelist()
    If Handlelist()\found=0
      Handlelist()\window\count-1
      Debug "Removehandle:"+Hex(Handlelist()\handle)+" "+Handlelist()\window\count
     
      DeleteMapElement(Handlelist())
    EndIf
  Next
  
  ForEach WindowList()
    If WindowList()\count=0
      If WindowList()\color=#False
        ;Debug "grey:"+WindowList()\Title
        GreyPos(gadList,WindowList()\pos)
        WindowList()\color=#True
      EndIf
    Else
      If WindowList()\color=#True
        ;Debug "normal:"+WindowList()\Title
        normalpos(gadList,WindowList()\pos)
        WindowList()\color=#False
      EndIf
    EndIf
  Next
  
  
EndProcedure

Procedure MaxRemove(*window.sWindowList)
  ForEach Handlelist()
    If Handlelist()\window=*window
      Handlelist()\maximized=0
    EndIf
  Next
EndProcedure


Define flags,event,pos,count,*window.swindowlist,systray,MenuList,i,MenuTray

Enumeration menu
  #men_exit
  #men_open
  #men_enable
  #men_resize
  
  #men_frame  
  #men_lastFrame=#men_frame+#frm__max-1 
  
  #men_monitorClose  
  #men_monitor
  #men_lastMonitor=#men_monitor+99
EndEnumeration

menuTray=CreatePopupMenu(#PB_Any)
MenuItem(#men_open,"Open")
MenuItem(#men_exit,"Exit")

menuList=CreatePopupMenu(#PB_Any)
MenuItem(#men_enable,"Enable")
MenuBar()
For i=0 To monitorCount-1
  MenuItem(#men_monitor+i,"Display "+Str(i+1))
Next
MenuBar()
MenuItem(#men_frame+#frm_default,"Normal frame")
MenuItem(#men_frame+#frm_remove,"without frame (with visible taskbar)")
MenuItem(#men_frame+#frm_removemax,"without frame")
MenuBar()
MenuItem(#men_monitorClose,"Close first window")
MenuBar()
MenuItem(#men_resize,"Force Resize")

LoadSettings(#title+".ini")

If winw<0 Or winh<0 Or CheckInMonitor(winx,winy,winw,winh)=#False
  winw=800
  winh=600
  flags=#PB_Window_ScreenCentered
EndIf

win=OpenWindow(#PB_Any,winx,winy,winw,winh,#title+"-"+#version,flags | #PB_Window_SystemMenu|#PB_Window_Invisible|#PB_Window_MinimizeGadget|#PB_Window_SizeGadget)
If win=0
  MessageRequester(#title,"Can't open window")
  End
EndIf

gadList=ListIconGadget(#PB_Any,5,5,0,0,"Title",0, #PB_ListIcon_FullRowSelect|#PB_ListIcon_CheckBoxes  )
AddGadgetColumn(gadList,1,"Class",0)
AddGadgetColumn(gadList,2,"Display",100)

FillList()
WinResize()
scan()

AddWindowTimer(win,1,1000)
#GCLP_HICON=-14
icon=GetClassLongPtr_(WindowID(win),#GCLP_HICON)

systray=AddSysTrayIcon(#PB_Any,WindowID(win),icon)
SysTrayIconToolTip(systray,#title+" - "+#version)

Repeat
  event=WaitWindowEvent()
  Select event
    Case #PB_Event_SysTray
      Select EventType()
        Case #PB_EventType_LeftClick,#PB_EventType_LeftDoubleClick
          FillList()
          scan()
          HideWindow(win,#False)
          SetWindowState(win,#PB_Window_Normal)
          SetActiveWindow(win)
          winvisible=#True
        Case #PB_EventType_RightClick
          DisplayPopupMenu(MenuTray,WindowID(win))
      EndSelect      
          
    Case #PB_Event_Timer
      ;Debug "Heartbeat"
      scan()
      
    Case #PB_Event_Menu
      Select EventMenu()
        Case #men_exit
          Break
          
        Case #men_open
          FillList()
          scan()
          HideWindow(win,#False)
          SetWindowState(win,#PB_Window_Normal)
          SetActiveWindow(win)
          winvisible=#True
          
        Case #men_resize
          If *window
            MaxRemove(*window)
          EndIf
                    
        Case #men_enable
          If *window
            *window\enable ! #PB_ListIcon_Checked
            SetGadgetItemState(gadList,*window\pos,*window\enable)
          EndIf
          
        Case #men_frame  To #men_lastFrame
          If *window
            *window\noFrame=EventMenu() - (#men_frame + #frm__min)
            SetDisplayText(*window)
            MaxRemove(*window)
            ;*window\maximized=#False
          EndIf
          
        Case #men_monitorClose
          If *window
            *window\monitor=-1
            SetDisplayText(*window)
            MaxRemove(*window)
          EndIf
          
        Case #men_monitor To #men_lastMonitor
          If *window
            *window\monitor=EventMenu()-#men_monitor
            SetDisplayText(*window)
            MaxRemove(*window)
            ;*window\maximized=#False
          EndIf
          
      EndSelect
      
    Case #PB_Event_Gadget
      Select EventType()
        Case #PB_EventType_RightClick
          pos=GetGadgetState(gadList)
          *window=GetGadgetItemData(gadList,pos)
          ;Debug *window
          If *window
            SetMenuItemState(MenuList,#men_enable,Bool(*window\enable))
            For i=#frm__min To #frm__max-1
              SetMenuItemState(MenuList,#men_frame+i,Bool(*window\noFrame=i))
            Next
            For i=-1 To monitorCount-1
              SetMenuItemState(MenuList,#men_monitor+i,Bool(i=*window\monitor))
            Next
            DisplayPopupMenu(MenuList,WindowID(win))
          EndIf

          
        Case  #PB_EventType_Change
          
          count=CountGadgetItems(gadList)-1
          For pos=0 To count
            *window=GetGadgetItemData(gadList,pos)
            If *window
              *window\enable=GetGadgetItemState(gadList,pos) & #PB_ListIcon_Checked
            EndIf
          Next
          
      EndSelect
    Case #PB_Event_SizeWindow
      WinResize()
    Case #PB_Event_MinimizeWindow
      SaveSettings(#title+".ini")
      HideWindow(win,#True)
      winvisible=#False
    Case #PB_Event_CloseWindow
      Break
  EndSelect
ForEver

SetWindowState(win,#PB_Window_Normal)
Repeat:Until WindowEvent()=0
winx=WindowX(win)
winy=WindowY(win)
winw=WindowWidth(win)
winh=WindowHeight(win)

SaveSettings(#title+".ini")

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 43
; FirstLine = 17
; Folding = 4k--
; EnableXP
; UseIcon = if_window_fullscreen_15568.ico
; Executable = C:\Programme_NoInstall\FullScreenEnabler.exe
; CurrentDirectory = C:\Programme_NoInstall